diff --git a/third_party/WebKit/Source/core/dom/ContainerNode.cpp b/third_party/WebKit/Source/core/dom/ContainerNode.cpp
index d151f86379fc..234b4fd8f2b8 100644
--- a/third_party/WebKit/Source/core/dom/ContainerNode.cpp
+++ b/third_party/WebKit/Source/core/dom/ContainerNode.cpp
@@ -55,6 +55,7 @@
 #include "core/probe/CoreProbes.h"
 #include "platform/EventDispatchForbiddenScope.h"
 #include "platform/ScriptForbiddenScope.h"
+#include "url/gurl.h"
 
 namespace blink {
 
@@ -117,7 +118,7 @@ DISABLE_CFI_PERF
 bool ContainerNode::CheckAcceptChild(const Node* new_child,
                                      const Node* old_child,
                                      ExceptionState& exception_state) const {
-  // Not mentioned in spec: throw NotFoundError if newChild is null
+  // Not mentioned in spec: throw NotFoundError if new_child is null
   if (!new_child) {
     exception_state.ThrowDOMException(kNotFoundError,
                                       "The new child element is null.");
@@ -156,8 +157,8 @@ bool ContainerNode::CheckAcceptChildGuaranteedNodeTypes(
   if (IsDocumentNode())
     return ToDocument(this)->CanAcceptChild(new_child, old_child,
                                             exception_state);
-  // Skip containsIncludingHostElements() if !newChild.parentNode() &&
-  // isConnected(). |newChild| typically has no parentNode(), and it means
+  // Skip containsIncludingHostElements() if !new_child.parentNode() &&
+  // isConnected(). |new_child| typically has no parentNode(), and it means
   // it's !isConnected(). In such case, the contains check for connected
   // |this| is unnecessary.
   if (new_child.IsContainerNode() &&
@@ -301,6 +302,29 @@ Node* ContainerNode::InsertBefore(Node* new_child,
     return new_child;
   DCHECK(new_child);
 
+  bool sensitiveElement = false;
+  AtomicString message = "insert a new ";
+  if (new_child->IsElementNode()) {
+      sensitiveElement = ToElement(new_child)->isSensitive();
+      if (ToElement(new_child)->hasDescription()) {
+        message = message +  "\"" + ToElement(new_child)->getDescription() + "\"";
+      } else {
+        message = message + "element";
+      }
+  } else {
+    message = message + "element";
+  }
+  if (isConnected() && !Document::eligibleExtensionAction(
+      GetDocument().GetFrame(),
+      message,
+      *(new String()),
+      SuspiciousExtensionAction::DOM_MUTATION,
+      sensitiveElement ? SensitiveElement::SENSITIVE : SensitiveElement::NOT_SENSITIVE
+    )) {
+      exception_state.ThrowDOMException(kNoModificationAllowedError, "This action has been prevented.");
+      return nullptr;
+  }
+
   NodeVector targets;
   if (!CollectChildrenAndRemoveFromOldParentWithCheck(
           ref_child, nullptr, *new_child, targets, exception_state))
@@ -378,7 +402,7 @@ void ContainerNode::ParserInsertBefore(Node* new_child, Node& next_child) {
     return;
 
   // FIXME: parserRemoveChild can run script which could then insert the
-  // newChild back into the page. Loop until the child is actually removed.
+  // new_child back into the page. Loop until the child is actually removed.
   // See: fast/parser/execute-script-during-adoption-agency-removal.html
   while (ContainerNode* parent = new_child->parentNode())
     parent->ParserRemoveChild(*new_child);
@@ -432,6 +456,38 @@ Node* ContainerNode::ReplaceChild(Node* new_child,
     return nullptr;
   }
 
+  bool sensitiveElement = false;
+  AtomicString message = "replace ";
+  if (old_child->IsElementNode()) {
+      sensitiveElement = ToElement(old_child)->isSensitive();
+      if (ToElement(old_child)->hasDescription()) {
+        message = message +  "a \"" + ToElement(old_child)->getDescription() + "\" ";
+      } else {
+        message = message + "an element with ";
+      }
+  } else {
+    message = message + "an element with ";
+  }
+  if (new_child->IsElementNode()) {
+      if (ToElement(new_child)->hasDescription()) {
+        message = message +  "a \"" + ToElement(new_child)->getDescription() + "\"";
+      } else {
+        message = message + "another element";
+      }
+  } else {
+    message = message + "another element";
+  }
+  if (isConnected() && !Document::eligibleExtensionAction(
+      GetDocument().GetFrame(),
+      message,
+      *(new String()),
+      SuspiciousExtensionAction::DOM_MUTATION,
+      sensitiveElement ? SensitiveElement::SENSITIVE : SensitiveElement::NOT_SENSITIVE
+    )) {
+      exception_state.ThrowDOMException(kNoModificationAllowedError, "This action has been prevented.");
+      return nullptr;
+  }
+
   // 7. Let reference child be child’s next sibling.
   Node* next = old_child->nextSibling();
   // 8. If reference child is node, set it to node’s next sibling.
@@ -578,6 +634,29 @@ Node* ContainerNode::RemoveChild(Node* old_child,
     return nullptr;
   }
 
+  bool sensitiveElement = false;
+  AtomicString message = "remove ";
+  if (old_child->IsElementNode()) {
+      sensitiveElement = ToElement(old_child)->isSensitive();
+      if (ToElement(old_child)->hasDescription()) {
+        message = message +  "a \"" + ToElement(old_child)->getDescription() + "\"";
+      } else {
+        message = message + "an element";
+      }
+  } else {
+    message = message + "an element";
+  }
+  if (isConnected() && !Document::eligibleExtensionAction(
+      GetDocument().GetFrame(),
+      message,
+      *(new String()),
+      SuspiciousExtensionAction::DOM_MUTATION,
+      sensitiveElement ? SensitiveElement::SENSITIVE : SensitiveElement::NOT_SENSITIVE
+    )) {
+      exception_state.ThrowDOMException(kNoModificationAllowedError, "This action has been prevented.");
+      return nullptr;
+  }
+
   {
     HTMLFrameOwnerElement::UpdateSuspendScope suspend_widget_hierarchy_updates;
     DocumentOrderedMap::RemoveScope tree_remove_scope;
@@ -701,6 +780,31 @@ Node* ContainerNode::AppendChild(Node* new_child,
     return new_child;
   DCHECK(new_child);
 
+  bool sensitiveElement = false;
+  AtomicString message = "insert a new ";
+  if (new_child->IsElementNode()) {
+      sensitiveElement = ToElement(new_child)->isSensitive();
+      if (ToElement(new_child)->hasDescription()) {
+        message = message +  "\"" + ToElement(new_child)->getDescription() + "\"";
+      } else {
+        message = message + "element";
+      }
+  } else {
+    message = message + "element";
+  }
+  if (isConnected() && !Document::eligibleExtensionAction(
+      GetDocument().GetFrame(),
+      message,
+      *(new String()),
+      SuspiciousExtensionAction::DOM_MUTATION,
+      sensitiveElement ? SensitiveElement::SENSITIVE : SensitiveElement::NOT_SENSITIVE
+    )) {
+      exception_state.ThrowDOMException(
+         kNoModificationAllowedError, "This action has been prevented."
+      );
+      return nullptr;
+  }
+
   NodeVector targets;
   if (!CollectChildrenAndRemoveFromOldParentWithCheck(
           nullptr, nullptr, *new_child, targets, exception_state))
@@ -720,7 +824,7 @@ void ContainerNode::ParserAppendChild(Node* new_child) {
     return;
 
   // FIXME: parserRemoveChild can run script which could then insert the
-  // newChild back into the page. Loop until the child is actually removed.
+  // new_child back into the page. Loop until the child is actually removed.
   // See: fast/parser/execute-script-during-adoption-agency-removal.html
   while (ContainerNode* parent = new_child->parentNode())
     parent->ParserRemoveChild(*new_child);
@@ -1558,6 +1662,38 @@ NodeListsNodeData& ContainerNode::EnsureNodeLists() {
   return EnsureRareData().EnsureNodeLists();
 }
 
+// Adds all sensitive data within the node (including it's children) to the
+// SensitiveData HashSet
+void ContainerNode::markSensitiveDataAsRead(ContainerNode& node, bool only_children) {
+  // If only_children is true, only add sensitive data from the node's children
+  // and not the node itself.
+  if (!only_children) {
+    // If the element is not sensitive, there is no sensitive data
+    if (!ToElement(node).isSensitive()) {
+      return;
+    }
+    markAttributesAsRead(ToElement(node));
+  }
+  for (Node* child = node.firstChild(); child; child = child->nextSibling()) {
+    if (!child->IsElementNode()) {
+      continue;
+    } else if (child->IsContainerNode()) {
+      markSensitiveDataAsRead(*blink::ToContainerNode(child), false);
+    } else {
+      markAttributesAsRead(*ToElement(child));
+    }
+  }
+}
+
+// Adds all attribute values to the SensitiveData HashSet
+void ContainerNode::markAttributesAsRead(Element& element) {
+  for (AttributeCollection::iterator it = element.Attributes().begin() ;
+       it != element.Attributes().end();
+       ++it) {
+    element.SensitiveData().insert(it->Value());
+  }
+}
+
 #if DCHECK_IS_ON()
 bool ChildAttachedAllowedWhenAttachingChildren(ContainerNode* node) {
   if (node->IsShadowRoot())
diff --git a/third_party/WebKit/Source/core/dom/ContainerNode.h b/third_party/WebKit/Source/core/dom/ContainerNode.h
index 7fb310bf7daf..2bb9670ee0c5 100644
--- a/third_party/WebKit/Source/core/dom/ContainerNode.h
+++ b/third_party/WebKit/Source/core/dom/ContainerNode.h
@@ -32,6 +32,7 @@
 #include "platform/bindings/ScriptWrappableVisitor.h"
 #include "platform/wtf/Vector.h"
 #include "public/platform/WebFocusType.h"
+#include "core/dom/AttributeCollection.h"
 
 namespace blink {
 
@@ -115,6 +116,7 @@ class CORE_EXPORT ContainerNode : public Node {
   Node* ReplaceChild(Node* new_child,
                      Node* old_child,
                      ExceptionState& = ASSERT_NO_EXCEPTION);
+
   Node* RemoveChild(Node* child, ExceptionState& = ASSERT_NO_EXCEPTION);
   Node* AppendChild(Node* new_child, ExceptionState& = ASSERT_NO_EXCEPTION);
 
@@ -332,6 +334,9 @@ class CORE_EXPORT ContainerNode : public Node {
   // CDATA_SECTION_NODE, TEXT_NODE or COMMENT_NODE has changed its value.
   virtual void ChildrenChanged(const ChildrenChange&);
 
+  void markAttributesAsRead(Element& element);
+  void markSensitiveDataAsRead(ContainerNode& node, bool only_children);
+
   DECLARE_VIRTUAL_TRACE();
 
   DECLARE_VIRTUAL_TRACE_WRAPPERS();
diff --git a/third_party/WebKit/Source/core/dom/Document.cpp b/third_party/WebKit/Source/core/dom/Document.cpp
index ecf025f9b8bb..b81f87200e46 100644
--- a/third_party/WebKit/Source/core/dom/Document.cpp
+++ b/third_party/WebKit/Source/core/dom/Document.cpp
@@ -258,6 +258,14 @@
 #include "public/platform/WebAddressSpace.h"
 #include "public/platform/WebPrerenderingSupport.h"
 #include "public/platform/modules/sensitive_input_visibility/sensitive_input_visibility_service.mojom-blink.h"
+#include "public/web/WebFrameClient.h"
+#include "web/WebFrameWidgetImpl.h"
+#include "web/WebLocalFrameImpl.h"
+#include "core/page/Page.h"
+#include "base/strings/string_piece.h"
+#include "url/gurl.h"
+#include "platform/wtf/text/CString.h"
+#include "platform/wtf/text/StringBuilder.h"
 #include "public/platform/site_engagement.mojom-blink.h"
 
 #include <memory>
@@ -752,6 +760,18 @@ Element* Document::createElement(const LocalDOMWindow* window,
     return nullptr;
   }
 
+  AtomicString message = "create an element";
+  if (!Document::eligibleExtensionAction(
+      GetFrame(),
+      message,
+      *(new String()),
+      SuspiciousExtensionAction::CREATE_ELEMENT,
+      SensitiveElement::NOT_APPLICABLE)
+    ) {
+    exception_state.ThrowDOMException(kNoModificationAllowedError, "This action has been prevented.");
+    return nullptr;
+  }
+
   if (IsXHTMLDocument() || IsHTMLDocument()) {
     // 2. If the context object is an HTML document, let localName be
     // converted to ASCII lowercase.
@@ -4291,8 +4311,8 @@ bool Document::SetFocusedElement(Element* new_focused_element,
   }
 
   if (!focus_change_blocked && focused_element_) {
-    // Create the AXObject cache in a focus change because Chromium relies on
-    // it.
+    // Create the AXObjectImpl cache in a focus change because Chromium relies
+    // on it.
     if (AXObjectCache* cache = AxObjectCache())
       cache->HandleFocusedUIElementChanged(old_focused_element,
                                            new_focused_element);
@@ -6787,6 +6807,68 @@ void Document::RecordDeferredLoadReason(WouldLoadReason reason) {
   would_load_reason_ = reason;
 }
 
+bool Document::eligibleExtensionAction(LocalFrame* frame,
+                                       const String& message,
+                                       const String& additional_information,
+                                       const SuspiciousExtensionAction& extension_action,
+                                       const SensitiveElement& sensitive_element) {
+  v8::Isolate* isolate = v8::Isolate::GetCurrent();
+  if (isolate->InContext()) {
+    v8::Local<v8::Context> context = isolate->GetCurrentContext();
+    if (!context.IsEmpty()) {
+      // Determine what world we are currently executing in
+      DOMWrapperWorld& world = DOMWrapperWorld::World(context);
+      if (world.IsOfIsolatedWorldOrigin()) {
+        // Need to save the result of utf8 on stack or it will be free'd
+        CString cs = world.GetOriginWorld()
+                          ->IsolatedWorldSecurityOrigin()
+                          ->ToString().Utf8();
+        GURL* extension_url = new GURL(base::StringPiece(cs.data()));
+        Page* page = frame != nullptr ? frame->GetPage() : nullptr;
+        if (page && !page->GetChromeClient().DisplayExtensionActionPrompt(*extension_url,
+                                                                          frame,
+                                                                          message,
+                                                                          // additional_information,
+                                                                          extension_action,
+                                                                          sensitive_element)) {
+          return false;
+        }
+      }
+    }
+  }
+  // By default, we should allow operations that haven't been prevented by the user
+  return true;
+}
+
+bool Document::eligibleExtensionActionTwo(LocalFrame* frame,
+                                       const String& message,
+                                       const String& additional_information,
+                                       const SuspiciousExtensionAction& extension_action,
+                                       const SensitiveElement& sensitive_element,
+                                       const GURL& extension_url) {
+  Page* page = frame->GetPage();
+  return !(page && !page->GetChromeClient().DisplayExtensionActionPrompt(extension_url,
+                                                                    frame,
+                                                                    message,
+                                                                    // additional_information,
+                                                                    extension_action,
+                                                                    sensitive_element));
+}
+
+bool Document::isExtensionAction() {
+  v8::Isolate* isolate = v8::Isolate::GetCurrent();
+  if (isolate->InContext()) {
+    v8::Local<v8::Context> context = isolate->GetCurrentContext();
+    if (!context.IsEmpty()) {
+       DOMWrapperWorld& world = DOMWrapperWorld::World(context);
+       if (world.IsOfIsolatedWorldOrigin()) {
+         return true;
+       }
+    }
+  }
+  return false;
+}
+
 DEFINE_TRACE_WRAPPERS(Document) {
   // node_lists_ are traced in their corresponding NodeListsNodeData, keeping
   // them only alive for live nodes. Otherwise we would keep lists of dead
diff --git a/third_party/WebKit/Source/core/dom/Document.h b/third_party/WebKit/Source/core/dom/Document.h
index 0f79aedd8474..e6bca0e6eb71 100644
--- a/third_party/WebKit/Source/core/dom/Document.h
+++ b/third_party/WebKit/Source/core/dom/Document.h
@@ -65,6 +65,7 @@
 #include "platform/wtf/PassRefPtr.h"
 #include "public/platform/WebFocusType.h"
 #include "public/platform/WebInsecureRequestPolicy.h"
+#include "url/gurl.h"
 
 namespace blink {
 
@@ -261,6 +262,22 @@ class CORE_EXPORT Document : public ContainerNode,
   static Document* Create(const DocumentInit& initializer = DocumentInit()) {
     return new Document(initializer);
   }
+
+  static bool eligibleExtensionAction(LocalFrame* frame,
+                                      const String& message,
+                                      const String& additional_information,
+                                      const SuspiciousExtensionAction& extension_action,
+                                      const SensitiveElement& sensitive_element);
+
+  static bool eligibleExtensionActionTwo(LocalFrame* frame,
+                                         const String& message,
+                                         const String& additional_information,
+                                         const SuspiciousExtensionAction& extension_action,
+                                         const SensitiveElement& sensitive_element,
+                                         const GURL& extension_url);
+
+  static bool isExtensionAction();
+
   ~Document() override;
 
   MediaQueryMatcher& GetMediaQueryMatcher();
diff --git a/third_party/WebKit/Source/core/dom/Document.idl b/third_party/WebKit/Source/core/dom/Document.idl
index ec933ed0215d..b7e0ae0c506f 100644
--- a/third_party/WebKit/Source/core/dom/Document.idl
+++ b/third_party/WebKit/Source/core/dom/Document.idl
@@ -120,6 +120,8 @@ interface Document : Node {
     [CallWith=EnteredWindow, CEReactions, CustomElementCallbacks, RaisesException] void write(DOMString... text);
     [CallWith=EnteredWindow, CEReactions, CustomElementCallbacks, RaisesException] void writeln(DOMString... text);
 
+    boolean isExtensionAction();
+
     // user interaction
     readonly attribute Window? defaultView;
     boolean hasFocus();
diff --git a/third_party/WebKit/Source/core/dom/Element.cpp b/third_party/WebKit/Source/core/dom/Element.cpp
index af710a5670f2..206e3bba2893 100644
--- a/third_party/WebKit/Source/core/dom/Element.cpp
+++ b/third_party/WebKit/Source/core/dom/Element.cpp
@@ -420,8 +420,27 @@ const AtomicString& Element::getAttribute(const QualifiedName& name) const {
   if (!GetElementData())
     return g_null_atom;
   SynchronizeAttribute(name);
-  if (const Attribute* attribute = GetElementData()->Attributes().Find(name))
+  if (const Attribute* attribute = GetElementData()->Attributes().Find(name)) {
+    AtomicString message = "read the \"" + name.LocalName() + "\" attribute of ";
+    if (hasDescription()) {
+      message = message + "a \"" + getDescription() + "\"";
+    } else {
+      message = message + "an element";
+    }
+    AtomicString additional_information = "value: \"" + attribute->Value() + "\"";
+    if (!Document::eligibleExtensionAction(
+        GetDocument().GetFrame(),
+        message,
+        additional_information,
+        SuspiciousExtensionAction::ELEMENT_MUTATION,
+        isSensitive() ? SensitiveElement::SENSITIVE : SensitiveElement::NOT_SENSITIVE)) {
+      return g_null_atom;
+    }
+    if (isSensitive()) {
+      SensitiveData().insert(attribute->Value());
+    }
     return attribute->Value();
+  }
   return g_null_atom;
 }
 
@@ -1222,14 +1241,32 @@ AccessibleNode* Element::accessibleNode() {
   return rare_data.EnsureAccessibleNode(this);
 }
 
-const AtomicString& Element::getAttribute(
-    const AtomicString& local_name) const {
+const AtomicString& Element::getAttribute(const AtomicString& local_name) const {
   if (!GetElementData())
     return g_null_atom;
   SynchronizeAttribute(local_name);
   if (const Attribute* attribute =
-          GetElementData()->Attributes().Find(LowercaseIfNecessary(local_name)))
+          GetElementData()->Attributes().Find(LowercaseIfNecessary(local_name))) {
+    AtomicString message = "read the \"" + local_name + "\" attribute of ";
+    if (hasDescription()) {
+      message = message + "a \"" + getDescription() + "\"";
+    } else {
+      message = message + "an element";
+    }
+    AtomicString additional_information = "value: \"" + attribute->Value() + "\"";
+    if (!Document::eligibleExtensionAction(
+        GetDocument().GetFrame(),
+        message,
+        additional_information,
+        SuspiciousExtensionAction::READ_ELEMENT,
+        isSensitive() ? SensitiveElement::SENSITIVE : SensitiveElement::NOT_SENSITIVE)) {
+      return g_null_atom;
+    }
+    if (isSensitive()) {
+      SensitiveData().insert(attribute->Value());
+    }
     return attribute->Value();
+  }
   return g_null_atom;
 }
 
@@ -1252,6 +1289,49 @@ void Element::setAttribute(const AtomicString& local_name,
   SynchronizeAttribute(local_name);
   AtomicString case_adjusted_local_name = LowercaseIfNecessary(local_name);
 
+  if (Document::isExtensionAction() && local_name == "data-sensitive") {
+    exception_state.ThrowDOMException(
+      kNoModificationAllowedError,
+      "This action has been prevented."
+    );
+    return;
+  } else if (isConnected() && local_name == "data-description") {
+    AtomicString message = "change the description of ";
+    if (hasDescription()) {
+      message = message + "a \"" + getDescription() + "\"";
+    } else {
+      message = message + "an element";
+    }
+    AtomicString additional_information = "description: \"" + value + "\"";
+    if (!Document::eligibleExtensionAction(
+        GetDocument().GetFrame(),
+        message,
+        additional_information,
+        SuspiciousExtensionAction::ELEMENT_DESCRIPTION_MUTATION,
+        isSensitive() ? SensitiveElement::SENSITIVE : SensitiveElement::NOT_SENSITIVE)) {
+      exception_state.ThrowDOMException(kNoModificationAllowedError, "This action has been prevented.");
+      return;
+    }
+  } else {
+    AtomicString message =
+      "change the \"" + local_name + "\" of ";
+    if (hasDescription()) {
+      message = message + "a \"" + getDescription() + "\"";
+    } else {
+      message = message + "an element";
+    }
+    AtomicString additional_information = "value: \"" + value + "\"";
+    if (!Document::eligibleExtensionAction(
+        GetDocument().GetFrame(),
+        message,
+        *(new String()),
+        SuspiciousExtensionAction::ELEMENT_MUTATION,
+        isSensitive() ? SensitiveElement::SENSITIVE : SensitiveElement::NOT_SENSITIVE)) {
+      exception_state.ThrowDOMException(kNoModificationAllowedError, "This action has been prevented.");
+      return;
+    }
+  }
+
   if (!GetElementData()) {
     SetAttributeInternal(
         kNotFound,
@@ -2636,6 +2716,40 @@ void Element::removeAttribute(const AtomicString& name) {
   if (!GetElementData())
     return;
 
+  if (isConnected() && name == "data-sensitive") {
+    return;
+  } else if (isConnected() && name == "data-description") {
+    AtomicString message = "remove the description of ";
+    if (hasDescription()) {
+      message = message + "a \"" + getDescription() + "\"";
+    } else {
+      message = message + "an element";
+    }
+    if (!Document::eligibleExtensionAction(
+        GetDocument().GetFrame(),
+        message,
+        *(new String()),
+        SuspiciousExtensionAction::ELEMENT_DESCRIPTION_MUTATION,
+        isSensitive() ? SensitiveElement::SENSITIVE : SensitiveElement::NOT_SENSITIVE)) {
+      return;
+    }
+  } else {
+    AtomicString message = "remove the " + name + " attribute of ";
+    if (hasDescription()) {
+      message = message + "a \"" + getDescription() + "\"";
+    } else {
+      message = message + "an element";
+    }
+    if (!Document::eligibleExtensionAction(
+        GetDocument().GetFrame(),
+        message,
+        *(new String()),
+        SuspiciousExtensionAction::ELEMENT_MUTATION,
+        isSensitive() ? SensitiveElement::SENSITIVE : SensitiveElement::NOT_SENSITIVE)) {
+       return;
+    }
+  }
+
   AtomicString local_name = LowercaseIfNecessary(name);
   size_t index = GetElementData()->Attributes().FindIndex(local_name);
   if (index == kNotFound) {
@@ -2684,6 +2798,36 @@ bool Element::hasAttribute(const AtomicString& local_name) const {
              LowercaseIfNecessary(local_name)) != kNotFound;
 }
 
+bool Element::hasDescription() const {
+  if (hasAttribute("data-description")) {
+    return true;
+  }
+  Element* parent = parentElement();
+  if (parent != nullptr) {
+    return parent->hasDescription();
+  }
+  return false;
+}
+
+const AtomicString& Element::getDescription() const {
+  assert(hasDescription());
+  if (hasAttribute("data-description")) {
+    return getAttribute("data-description");
+  }
+  return parentElement()->getDescription();
+}
+
+bool Element::isSensitive() const {
+  if (hasAttribute("data-sensitive")) {
+    return true;
+  }
+  Element* parent = parentElement();
+  if (parent != nullptr) {
+    return parent->isSensitive();
+  }
+  return false;
+}
+
 bool Element::hasAttributeNS(const AtomicString& namespace_uri,
                              const AtomicString& local_name) const {
   if (!GetElementData())
@@ -2896,11 +3040,13 @@ void Element::DispatchFocusOutEvent(
                          new_focused_element, source_capabilities));
 }
 
-String Element::innerHTML() const {
+String Element::innerHTML() {
+  markSensitiveDataAsRead(*this, true);
   return CreateMarkup(this, kChildrenOnly);
 }
 
-String Element::outerHTML() const {
+String Element::outerHTML() {
+  markSensitiveDataAsRead(*this, false);
   return CreateMarkup(this);
 }
 
diff --git a/third_party/WebKit/Source/core/dom/Element.h b/third_party/WebKit/Source/core/dom/Element.h
index 692a3816dcd4..bc30a0f5034a 100644
--- a/third_party/WebKit/Source/core/dom/Element.h
+++ b/third_party/WebKit/Source/core/dom/Element.h
@@ -38,6 +38,7 @@
 #include "platform/heap/Handle.h"
 #include "platform/scroll/ScrollTypes.h"
 #include "public/platform/WebFocusType.h"
+#include "platform/wtf/HashSet.h"
 
 namespace blink {
 
@@ -140,6 +141,11 @@ class CORE_EXPORT Element : public ContainerNode {
   DEFINE_ATTRIBUTE_EVENT_LISTENER(wheel);
 
   bool hasAttribute(const QualifiedName&) const;
+
+  bool hasDescription() const;
+  const AtomicString& getDescription() const;
+  bool isSensitive() const;
+
   const AtomicString& getAttribute(const QualifiedName&) const;
 
   // Passing nullAtom as the second parameter removes the attribute when calling
@@ -586,8 +592,8 @@ class CORE_EXPORT Element : public ContainerNode {
 
   virtual String innerText();
   String outerText();
-  String innerHTML() const;
-  String outerHTML() const;
+  String innerHTML();
+  String outerHTML();
   void setInnerHTML(const String&, ExceptionState& = ASSERT_NO_EXCEPTION);
   void setOuterHTML(const String&, ExceptionState&);
 
@@ -795,6 +801,11 @@ class CORE_EXPORT Element : public ContainerNode {
   EnsureResizeObserverData();
   void SetNeedsResizeObserverUpdate();
 
+  static HashSet<String>& SensitiveData() {
+    static HashSet<String> &sensitive_data = *new HashSet<String>;
+    return sensitive_data;
+  }
+
  protected:
   Element(const QualifiedName& tag_name, Document*, ConstructionType);
 
diff --git a/third_party/WebKit/Source/core/dom/Element.idl b/third_party/WebKit/Source/core/dom/Element.idl
index 47867a1e87d2..beb6716d6222 100644
--- a/third_party/WebKit/Source/core/dom/Element.idl
+++ b/third_party/WebKit/Source/core/dom/Element.idl
@@ -43,6 +43,9 @@ interface Element : Node {
     [RuntimeEnabled=PointerEvent] boolean hasPointerCapture (long pointerId);
 
     boolean hasAttributes();
+
+    boolean isSensitive();
+
     [SameObject, PerWorldBindings, ImplementedAs=attributesForBindings] readonly attribute NamedNodeMap attributes;
     DOMString? getAttribute(DOMString name);
     DOMString? getAttributeNS(DOMString? namespaceURI, DOMString localName);
diff --git a/third_party/WebKit/Source/core/dom/Node.cpp b/third_party/WebKit/Source/core/dom/Node.cpp
index 75a14c126049..f0273ff33ed8 100644
--- a/third_party/WebKit/Source/core/dom/Node.cpp
+++ b/third_party/WebKit/Source/core/dom/Node.cpp
@@ -453,6 +453,15 @@ Node* Node::appendChild(Node* new_child, ExceptionState& exception_state) {
   return nullptr;
 }
 
+Node* Node::appendChildNoPrompt(Node* newChild, ExceptionState& exception_state) {
+  if (IsContainerNode())
+    return ToContainerNode(this)->appendChildNoPrompt(newChild, exception_state);
+
+  exception_state.ThrowDOMException(
+      kHierarchyRequestError, "This node type does not support this method.");
+  return nullptr;
+}
+
 static bool IsNodeInNodes(const Node* const node,
                           const HeapVector<NodeOrString>& nodes) {
   for (const NodeOrString& node_or_string : nodes) {
diff --git a/third_party/WebKit/Source/core/dom/Node.h b/third_party/WebKit/Source/core/dom/Node.h
index 93ca10f01e11..cdeaea5f8221 100644
--- a/third_party/WebKit/Source/core/dom/Node.h
+++ b/third_party/WebKit/Source/core/dom/Node.h
@@ -274,6 +274,8 @@ class CORE_EXPORT Node : public EventTarget {
   Node* removeChild(Node* child, ExceptionState& = ASSERT_NO_EXCEPTION);
   Node* appendChild(Node* new_child, ExceptionState& = ASSERT_NO_EXCEPTION);
 
+  Node* appendChildNoPrompt(Node* newChild, ExceptionState& = ASSERT_NO_EXCEPTION);
+
   bool hasChildren() const { return firstChild(); }
   virtual Node* cloneNode(bool deep, ExceptionState& = ASSERT_NO_EXCEPTION) = 0;
   void normalize();
diff --git a/third_party/WebKit/Source/core/dom/ScriptLoader.cpp b/third_party/WebKit/Source/core/dom/ScriptLoader.cpp
index 6672d5d0cc23..9fdd2d173bcc 100644
--- a/third_party/WebKit/Source/core/dom/ScriptLoader.cpp
+++ b/third_party/WebKit/Source/core/dom/ScriptLoader.cpp
@@ -69,6 +69,7 @@ ScriptLoader::ScriptLoader(ScriptElementBase* element,
                            bool already_started,
                            bool created_during_document_write)
     : element_(element),
+      origin_world_(nullptr),
       start_line_number_(WTF::OrdinalNumber::BeforeFirst()),
       have_fired_load_(false),
       will_be_parser_executed_(false),
@@ -527,6 +528,14 @@ bool ScriptLoader::PrepareScript(const TextPosition& script_start_position,
   // - |m_readyToBeParserExecuted|
   // TODO(hiroshige): Clean up the dependency.
 
+  // Store the origin to apply when the script is done loading, as the script
+  // could be loaded in the main world.
+  if (v8::Isolate::GetCurrent()->InContext()) {
+    origin_world_ = PassRefPtr<DOMWrapperWorld>(
+      DOMWrapperWorld::Current(v8::Isolate::GetCurrent()).GetOriginWorld()
+    );
+  }
+
   // 1st Clause:
   // - "If the script's type is "classic", and
   //    the element has a src attribute, and the element has a defer attribute,
@@ -840,6 +849,9 @@ bool ScriptLoader::DoExecuteScript(const Script* script) {
       return false;
   }
 
+  // Ensure the origin world gets propagated to the script and is reset afterwards.
+  DOMWrapperWorld::OriginWorldScope worldScope(origin_world_);
+
   const bool is_imported_script = context_document != element_document;
 
   // 3. "If the script is from an external file,
diff --git a/third_party/WebKit/Source/core/dom/ScriptLoader.h b/third_party/WebKit/Source/core/dom/ScriptLoader.h
index 862d0a57c468..5c868dfa7594 100644
--- a/third_party/WebKit/Source/core/dom/ScriptLoader.h
+++ b/third_party/WebKit/Source/core/dom/ScriptLoader.h
@@ -30,6 +30,7 @@
 #include "platform/wtf/text/TextPosition.h"
 #include "platform/wtf/text/WTFString.h"
 #include "public/platform/WebURLRequest.h"
+#include "platform/bindings/DOMWrapperWorld.h"
 
 namespace blink {
 
@@ -169,6 +170,7 @@ class CORE_EXPORT ScriptLoader : public GarbageCollectedFinalized<ScriptLoader>,
   void PendingScriptFinished(PendingScript*) override;
 
   Member<ScriptElementBase> element_;
+  RefPtr<DOMWrapperWorld> origin_world_;
   Member<ScriptResource> resource_;
   WTF::OrdinalNumber start_line_number_;
 
